function tf = automesh(varargin)
for i=1:length(varargin)
  ns(i).entries = size(varargin(i))~=1; // Location of non-singleton dimensions
  tmp=double(cell2mat(ns(i)));
  isvec(i) = sum(tmp)<=1;     // Is vector.
  nd(i) = ndims(varargin(i));    // Number of dimensions.
end
// True if inputs are 2-D, all vectors, and their non-singleton
// dimensions aren't along the same dimension.
tf = and(nd==2) & and(isvec) & ~isqual(ns(:));
endfunction

function rw=isqual(ns)
    [m,n]=size(ns);
    for i=1:(m-1)
        z(i)=isequal(ns(i),ns(i+1));
    end
    rw=(m-1)==sum(double(z));
endfunction