function y=ihpwt2(x,f1,f2,o)
    [nargout,nargin]=argn(0);
    if type(x)==8 then
        x=double(x);
    end
n=ceil(log2(max(size(x))));
if prod(size(x))<(2^n *2^n) then
    x(2^n,2^n)=0;
end
if size(x)==size(f1) then
    k=f1;
else
    if nargin==2
        if size(f1,1)>1 & size(f1,2)>1 then
            error('Kernel size not compataible!')
        end
        f=[1 1];
        o=1;
    end
    if nargin==3 then
        o=1;
    end
    k=hpwk(f1,f2,n,o);
end
d=diag(k*k');
d=d*d';
y=x*k';
y=(y'*k');
y=y./d;
endfunction